import queue.*;
import java.io.*;
import java.util.Scanner;

public class Main {
  public static int MAXBUCKETS = 10;
  public static int full[] = new int[MAXBUCKETS];
  public static int end[] = new int[MAXBUCKETS];
  private static int MaxQueued = 100000;
  private static Vertex traversed[] = new Vertex[MaxQueued];
  private static Queue queue = null;
  private static int queued = 0;
  private static int verticies = 0;

  public Main(String name) {
    File f = new File(name);
    try {
      Scanner s = new Scanner(f);
      MAXBUCKETS = s.nextInt();
      full = new int[MAXBUCKETS];
      for(int i = 0; i < MAXBUCKETS; i++) {
        full[i] = s.nextInt();
      }
      int[] init = new int[MAXBUCKETS];
      for(int i = 0; i < MAXBUCKETS; i++) {
        init[i] = s.nextInt();
      }
      enqueue(new Vertex(init));
      end = new int[MAXBUCKETS];
      for(int i = 0; i < MAXBUCKETS; i++) {
        end[i] = s.nextInt();
      }
    } catch(FileNotFoundException e) {
      System.err.println("File " + name + " not found");
      System.exit(1);
    }
  }

  public Vertex solve() {
    while(!queue.isEmpty()) {
      Vertex v = (Vertex) queue.pop();
      verticies++;
      if(v.isEnding()) return v;
      for(int i = 0; i < MAXBUCKETS; i++) {
        enqueue(new Vertex(v, Vertex.EMPTY, i, 0));
        enqueue(new Vertex(v, Vertex.FULL, i, 0));
        for(int j = 0; j < MAXBUCKETS; j++) {
          if(i != j) {
            enqueue(new Vertex(v, Vertex.POUR, i, j));
          }
        }
      }
    }
    return null;
  }

  public void enqueue(Vertex v) {
    if(queued == MaxQueued) {
      System.err.println("Prekrocen maximalni pocet uzlu");
      System.exit(1);
    }
    for(int i = 0; i < queued; i++) {
      if(traversed[i].equal(v)) return;
    }
    traversed[queued++] = v;
    queue.push(v);
  }

  public static void main(String[] args) {
    if(args.length < 2) {
      error();
    }
    if(args[0].equals("brute")) queue = new NormalQueue(10000);
    else if(args[0].equals("heuristic")) queue = new PriorityQueue(10000);
    else error();
    Main main = new Main(args[1]);
    Vertex solution = main.solve();
    System.out.println("Vertex traversed: " + verticies);
    System.out.println("Vertex generated: " + queued);
    if(solution == null) {
      System.out.println("Without solution");
    } else {
      while (solution.getPrevious() != null) {
        System.out.println(solution.toString());
        solution = solution.getPrevious();
      }
      System.out.println(solution.toString());
    }
  }

  private static void error() {
    System.err.println("Jako paramter zadejte heuristic nebo brute a jmeno vstupniho souboru");
    System.exit(1);
  }
}
